
## Filter data globally ----
betaTable.good <- betaTable[which(betaTable$nsnp >= min_nsnps & betaTable$cov >= min_cov & betaTable$beta >= equalCN.betaThr),]

## Compute
samples.ToAnalyze <- unique(betaTable.good$sample)

##
ploidyTable.list <- mclapply(samples.ToAnalyze,FUN=computeSamplePloidy, betaTable.good = betaTable.good, 
                             maxHomoDels = maxHomoDels, 
                             nCoresPerSample = perSampleCores, mc.preschedule=F,mc.cores=NsamplesToProcessInParallel)

ploidyTable <-  fromListToDF(ploidyTable.list)
ploidyTable$log2shift <- round(-log2(ploidyTable$ploidy/2),3)

cat(paste("[",Sys.time() ,"] Save ploidy table in ",ploidyTable_file,"\n",sep=""))

write.table(ploidyTable,file=ploidyTable_file,quote=F,sep="\t",row.names=F,col.names=T)