##############################################################################
##############################################################################
#
#  operations on evlution paths
#
##############################################################################
##############################################################################



## define a custom evo path for testing
ngenes <- 6
evoPath.causality <- matrix(data=0,nrow=ngenes,ncol=ngenes)
colnames(evoPath.causality) <- seq(1,ngenes,1)
rownames(evoPath.causality) <- seq(1,ngenes,1)
evoPath.occurrency <- evoPath.causality
evoPath.causality[1,] <- c(0,1,1,0,3,0)
evoPath.causality[2,] <- c(1,0,0,0,0,0)
evoPath.causality[3,] <- c(0,0,0,1,0,0)
evoPath.causality[4,] <- c(0,2,2,0,0,0)
evoPath.causality[5,] <- c(0,0,2,0,0,0)
evoPath.causality[6,] <- c(1,0,0,1,0,0)

evoPath.occurrency[1,] <- c(0,2,1,0,7,5)
evoPath.occurrency[2,] <- c(2,0,0,0,0,0)
evoPath.occurrency[3,] <- c(1,0,0,3,2,0)
evoPath.occurrency[4,] <- c(0,0,3,0,0,1)
evoPath.occurrency[5,] <- c(7,0,2,0,0,0)
evoPath.occurrency[6,] <- c(5,0,0,1,0,0)

evoPath <- list(causality = evoPath.causality, occurrency = evoPath.occurrency)
geneClasses <- list(A  = c(1,3), B = c(2,5,6), D = c(4))

evoPath1 <- evoPath
evoPath.causality.2 <- matrix(data=0,nrow=ngenes,ncol=ngenes)
colnames(evoPath.causality.2) <- seq(1,ngenes,1)
rownames(evoPath.causality.2) <- seq(1,ngenes,1)
evoPath.occurrency.2 <- evoPath.causality.2
evoPath.causality.2[1,] <- c(0,2,0,0,0,0)
evoPath.causality.2[2,] <- c(0,0,1,0,0,0)
evoPath.causality.2[3,] <- c(0,2,0,3,1,0)
evoPath.causality.2[4,] <- c(0,1,0,0,0,2)
evoPath.causality.2[5,] <- c(0,0,0,0,0,1)
evoPath.causality.2[6,] <- c(0,0,0,2,0,0)

evoPath.occurrency.2[1,] <- c(0,3,0,0,0,0)
evoPath.occurrency.2[2,] <- c(3,0,4,2,0,0)
evoPath.occurrency.2[3,] <- c(0,4,0,3,2,0)
evoPath.occurrency.2[4,] <- c(0,2,3,0,1,5)
evoPath.occurrency.2[5,] <- c(0,0,2,1,0,1)
evoPath.occurrency.2[6,] <- c(0,0,0,5,1,0)
evoPath2 <- list(causality = evoPath.causality.2, occurrency = evoPath.occurrency.2)


# #find only significative arrows
# #
#evoPath <- genesEvolutionPath.Path.me
getSignificativeArrows.binomTest <- function(evoPath,alpha=0.01){
  causality.mat <- evoPath$causality
  valid.mat <- evoPath$causality
  for(i in c(1:(nrow(causality.mat)-1))){
    for(j in c((i+1):nrow(causality.mat))){
      if ( causality.mat[i,j]+causality.mat[j,i] > 0){
        test<-binom.test(x=causality.mat[i,j],n=(causality.mat[i,j]+causality.mat[j,i]),p=0.5 )
        if(causality.mat[i,j]>=causality.mat[j,i] ){
          valid.mat[i,j] <- test$p.value      
          valid.mat[j,i] <- 0
        }else{
          valid.mat[i,j] <- 0
          valid.mat[j,i] <- test$p.value      
          
        }
      }

    }
  }
  # correact p.values
  p.values <- c(valid.mat)
  p.values <- p.adjust(p=p.values,method="fdr")  
  p.values[which(p.values > ( alpha / 2))] <- 0
  causaliy<-c(evoPath$causality)
  causaliy[which(p.values == 0)] <- 0
  valid.mat.out <- matrix(data=causaliy, nrow=nrow(valid.mat) )
  
  return(list(causality=valid.mat.out ,occurrency = evoPath$occurrency ))
}

#evoPath <- genesEvolutionPath.Path.lu
getSignificativeArrows.perc <- function(evoPath,perc=0.2){
  causality.mat <- evoPath$causality
  valid.mat <- evoPath$causality
  for(i in c(1:(nrow(causality.mat)-1))){
    for(j in c((i+1):nrow(causality.mat))){
      if ( causality.mat[i,j]+causality.mat[j,i] > 0){
        #test<-binom.test(x=causality.mat[i,j],n=(causality.mat[i,j]+causality.mat[j,i]),p=0.5 )
        if(causality.mat[i,j]>=causality.mat[j,i] ){
          valid.mat[i,j] <- causality.mat[i,j] / ( causality.mat[i,j]+causality.mat[j,i] )      
          valid.mat[j,i] <- 0
        }else{
          valid.mat[i,j] <- 0
          valid.mat[j,i] <- causality.mat[j,i] / ( causality.mat[i,j]+causality.mat[j,i] ) 
          
        }
      }
      
    }
  }
  # correact p.values
 # p.values <- c(valid.mat)
#  p.values <- p.adjust(p=p.values,method="fdr")  
#  p.values[which(p.values > ( alpha / 2))] <- 0
#  causaliy<-c(evoPath$causality)
#  causaliy[which(p.values == 0)] <- 0
 # valid.mat.out <- matrix(data=causaliy, nrow=nrow(valid.mat) )
  
  #hist(valid.mat,breaks=seq(0,1,0.01))
  
  valid.mat[which(valid.mat < (1 - perc))] <- 0
  valid.mat.out <- causality.mat
  valid.mat.out[which(valid.mat < (1 - perc))] <- 0
  
  return(list(causality=valid.mat.out ,occurrency = evoPath$occurrency ))
}




# 
# getSignificativeArrows.normal <- function(evoPath){
#   causality.mat <- evoPath$causality
#   valid.mat <- evoPath$causality
#   activeArcs <- which(causality.mat > 0,arr.ind=T )
#   i<-1
#   vals <- c()
#   for(i in c(1:nrow(activeArcs))){
#     val <- causality.mat[ activeArcs[i,1], activeArcs[i,2]] / (causality.mat[ activeArcs[i,1], activeArcs[i,2]] + causality.mat[ activeArcs[i,2], activeArcs[i,1] ])  
#     vals <- c(vals,val)
#     valid.mat[activeArcs[i,1], activeArcs[i,2]]   <- val
#   }
#   
#   
#   
#   
#   which(abs(vals-mean(vals,na.rm=TRUE)) > 2*sd(vals,na.rm=TRUE))
#   
#   sd.limit <- 2*sd(vals)
#   which(vals <  ( 0.5 - sd.limit))
#   
#   shapiro.test(vals)
#   
#   vals[which(vals<=qnorm(p=0.025,mean=0.5,sd=sd(vals)))]
#   
#   
#   which(pnorm(q=vals,mean=0.5,sd=sd(vals))<=0.01)
#   
#   
#   boxplot(vals)
#   
#   par(mfrow=c(2,1))
#   hist(vals,xlim=c(0,1),breaks=seq(0,1,0.01))
#   hist(rnorm(n=72,mean=0.5,sd= sd(vals)),xlim=c(0,1),breaks=seq(0,1,0.01))
#   
#   
#   
#   
# }


#remove bi-directional arrows
removeBiDirectional.EvoPath <- function(evoPath){
  
  # create a causality matrix with rows and columns swapped 
  causalityOriginal <- evoPath$causality
  causalityOrigina.trasp <- t(causalityOriginal)  
  
  mask <- !xor(causalityOriginal,causalityOrigina.trasp)
  causalityOriginal[mask]  <- 0
  
  return(list(causality = causalityOriginal, occurrency = evoPath$occurrency  ))
  
}

#take a list of sets of genes, and retunr a list of the same intersection but with pairwise empty intersection
cleanFromIntersection.geneList <- function(geneList){
  geneList.compact <- geneList
  geneList.compact[[1]] <- Reduce(setdiff,geneList)
  #i<-2
  for(i in c(2:length(geneList))){
    orderedName <- c(c(i,1),setdiff(seq(1:length(geneList)),c(i,1)))
    #cat(orderedName,"\n")
    geneList.compact[[i]] <-Reduce(setdiff,geneList[ orderedName ])
    #  Reduce(setdiff,geneListGO)
  }
  return(geneList.compact)
}


## difference of two evolution path
evoPath.diff <- function(evoPath1,evoPath2 ){
  #the output is as evoPath1 where intersectiong arcs are removed
  evoPathOut <- evoPath1
  
  evoPath1.arcs <- which(evoPath1$causality > 0,arr.ind=T)
  evoPath2.arcs <- which(evoPath2$causality > 0,arr.ind=T)
    
  evoPath1.arcs <- as.data.frame(evoPath1.arcs,stringsAsFactors=F,row.names=c(1:nrow(evoPath1.arcs)))
  evoPath1.arcs$globalId <- which(evoPath1$causality > 0)
  evoPath1.arcs$suorce <- rownames(evoPath1$causality)[ evoPath1.arcs$row ]
  evoPath1.arcs$dest <- colnames(evoPath1$causality)[ evoPath1.arcs$col ]
    
  evoPath2.arcs <- as.data.frame(evoPath2.arcs,stringsAsFactors=F,row.names=c(1:nrow(evoPath2.arcs)))
  evoPath2.arcs$globalId <- which(evoPath2$causality > 0)
  evoPath2.arcs$suorce <- rownames(evoPath2$causality)[ evoPath2.arcs$row ]
  evoPath2.arcs$dest <- colnames(evoPath2$causality)[ evoPath2.arcs$col ]
  
  evoPath1.arcs$unique <- paste0(evoPath1.arcs$suorce,"->",evoPath1.arcs$dest)
  evoPath2.arcs$unique <- paste0(evoPath2.arcs$suorce,"->",evoPath2.arcs$dest)

  arcsToRemove <- intersect(evoPath1.arcs$unique,evoPath2.arcs$unique)
  arcsToRemove.Ids <-  evoPath1.arcs$globalId[which(evoPath1.arcs$unique %in% arcsToRemove)]
  
  evoPathOut$causality[arcsToRemove.Ids] <- 0
  #evoPathOut$occurrency[arcsToRemove.Ids] <- 0
  
  return(evoPathOut)
}

## union of two evolution path
#evoPath1 <- evoPath1.clean
#evoPath2 <- evoPath2.clean
evoPath.union <- function(evoPath1,evoPath2 ){
  
  evoPath1.arcs <- which(evoPath1$causality > 0,arr.ind=T)
  evoPath2.arcs <- which(evoPath2$causality > 0,arr.ind=T)
  
  evoPath1.arcs <- as.data.frame(evoPath1.arcs,stringsAsFactors=F,row.names=c(1:nrow(evoPath1.arcs)))
  evoPath1.arcs$globalId <- which(evoPath1$causality > 0)
  evoPath1.arcs$suorce <- rownames(evoPath1$causality)[ evoPath1.arcs$row ]
  evoPath1.arcs$dest <- colnames(evoPath1$causality)[ evoPath1.arcs$col ]
  
  evoPath2.arcs <- as.data.frame(evoPath2.arcs,stringsAsFactors=F,row.names=c(1:nrow(evoPath2.arcs)))
  evoPath2.arcs$globalId <- which(evoPath2$causality > 0)
  evoPath2.arcs$suorce <- rownames(evoPath2$causality)[ evoPath2.arcs$row ]
  evoPath2.arcs$dest <- colnames(evoPath2$causality)[ evoPath2.arcs$col ]
  
  evoPath1.arcs$unique <- paste0(evoPath1.arcs$suorce,"->",evoPath1.arcs$dest)
  evoPath2.arcs$unique <- paste0(evoPath2.arcs$suorce,"->",evoPath2.arcs$dest)
  
  #arcsToKeep <- unique(c(evoPath1.arcs$unique,evoPath2.arcs$unique))
  #evoPath1.arcsToKeep <-  evoPath1.arcs[which(evoPath1.arcs$unique %in% arcsToKeep),]
  #evoPath2.arcsToKeep <-  evoPath2.arcs[which(evoPath2.arcs$unique %in% arcsToKeep),]
  
  #outGenes <- unique(c(evoPath1.arcsToKeep$suorce,evoPath1.arcsToKeep$dest,evoPath2.arcsToKeep$suorce,evoPath2.arcsToKeep$dest) )
  #outGenes <- unique(colnames(evoPath1$causality),colnames(evoPath2$causality) )
  outGenes <- unique(c(colnames(evoPath2$causality),colnames(evoPath1$causality) ))
  
  evoPathOut.causality <- matrix(data=0,nrow=length(outGenes),ncol=length(outGenes))
  rownames(evoPathOut.causality) <- outGenes
  colnames(evoPathOut.causality) <- outGenes
  evoPathOut.occurency <- evoPathOut.causality
  
  colName <- colnames(evoPath1$causality)[3]
  for(colName in colnames(evoPath1$causality)){
    evoPathOut.causality[rownames(evoPath1$causality),colName] <- 
      evoPathOut.causality[rownames(evoPath1$causality),colName] + evoPath1$causality[rownames(evoPath1$causality),colName ]
    evoPathOut.occurency[rownames(evoPath1$occurrency),colName] <- 
      evoPathOut.occurency[rownames(evoPath1$occurrency),colName] + evoPath1$occurrency[rownames(evoPath1$occurrency),colName ]
    
  }
  
  for(colName in colnames(evoPath2$causality)){
    evoPathOut.causality[rownames(evoPath2$causality),colName] <- 
      evoPathOut.causality[rownames(evoPath2$causality),colName] + evoPath2$causality[rownames(evoPath2$causality),colName ]
    evoPathOut.occurency[rownames(evoPath2$occurrency),colName] <- 
      evoPathOut.occurency[rownames(evoPath2$occurrency),colName] + evoPath2$occurrency[rownames(evoPath2$occurrency),colName ]
    
  }
  
  
  
  return(list(causality=evoPathOut.causality, occurrency=evoPathOut.occurency))
}


## intersect of two evolution path
#evoPath1 <-ep.CHD1pSPOPp
#evoPath2 <- ep.CHD1pSPOPn
evoPath.intersect <- function(evoPath1,evoPath2, minDep = 1 ){
  
  evoPath1.arcs <- which(evoPath1$causality >= minDep,arr.ind=T)
  evoPath2.arcs <- which(evoPath2$causality >= minDep,arr.ind=T)
  
  evoPath1.arcs <- as.data.frame(evoPath1.arcs,stringsAsFactors=F,row.names=c(1:nrow(evoPath1.arcs)))
  evoPath1.arcs$globalId <- which(evoPath1$causality >= minDep)
  evoPath1.arcs$suorce <- rownames(evoPath1$causality)[ evoPath1.arcs$row ]
  evoPath1.arcs$dest <- colnames(evoPath1$causality)[ evoPath1.arcs$col ]
  
  evoPath2.arcs <- as.data.frame(evoPath2.arcs,stringsAsFactors=F,row.names=c(1:nrow(evoPath2.arcs)))
  evoPath2.arcs$globalId <- which(evoPath2$causality >= minDep)
  evoPath2.arcs$suorce <- rownames(evoPath2$causality)[ evoPath2.arcs$row ]
  evoPath2.arcs$dest <- colnames(evoPath2$causality)[ evoPath2.arcs$col ]
  
  evoPath1.arcs$unique <- paste0(evoPath1.arcs$suorce,"->",evoPath1.arcs$dest)
  evoPath2.arcs$unique <- paste0(evoPath2.arcs$suorce,"->",evoPath2.arcs$dest)
  

  arcsToRemove.1 <- setdiff(evoPath1.arcs$unique,evoPath2.arcs$unique)
  arcsToRemove.2 <- setdiff(evoPath2.arcs$unique,evoPath1.arcs$unique)
  
  
  arcsToRemove.id1 <- evoPath1.arcs$globalId[which(evoPath1.arcs$unique %in% arcsToRemove.1)]
  arcsToRemove.id2 <- evoPath2.arcs$globalId[which(evoPath2.arcs$unique %in% arcsToRemove.2)]

  evoPath1.clean <- evoPath1
  evoPath2.clean <- evoPath2
  
  evoPath1.clean$causality[ arcsToRemove.id1 ] <- 0
  evoPath2.clean$causality[ arcsToRemove.id2 ] <- 0

  
  return(evoPath.union(evoPath1.clean,evoPath2.clean))
  
}


### Aggreate n classes
## it takes a list of gene classes, where a class is a set of genes
## the classes have pairwise empty intersection
## and compute the agggregated evoPath
## node labels are list names
# evoPath <- genesEvolutionPath.pr
# geneClasses <- geneListGO
evoPath.projectOnGenes.emptyIntersection <- function(evoPath, geneClasses, name.separator="~"  ){
  
  nClasses <- length(names(geneClasses))
  nameClasses <- names(geneClasses)
  out.causality <- matrix(data=0,nrow=nClasses,nClasses)
  rownames(out.causality) <- nameClasses
  colnames(out.causality) <- nameClasses
  out.occurrency <- out.causality

  geneClassesComb <- combn(nameClasses,m=2)
  
#  combID <- 2
  getCombDep <- function(combID, geneClassesComb, geneClasses, evoPath){
    
    cat(combID,".. ")
    firstClass <- geneClassesComb[1,combID]
    secondClass <- geneClassesComb[2,combID]

    evoPath.geneList <- do.call(rbind,strsplit(rownames(evoPath$causality),split=name.separator) )
    firstGeneClass.id <-  which( evoPath.geneList[,1] %in% geneClasses[[firstClass]])
    secondGeneClass.id <-  which( evoPath.geneList[,1] %in% geneClasses[[secondClass]])
    

    firstToSecond.causality <- evoPath$causality[firstGeneClass.id,,drop=F]
    firstToSecond.causality <- firstToSecond.causality[,secondGeneClass.id,drop=F]
    firstToSecond.caus.val <- sum(apply(firstToSecond.causality,1,sum),na.rm=T)
    
    secondToFirst.causality <- evoPath$causality[secondGeneClass.id,,drop=F]
    secondToFirst.causality <- secondToFirst.causality[,firstGeneClass.id,drop=F]
    secondToFirst.caus.val <- sum(apply(secondToFirst.causality,1,sum),na.rm=T)
  
    firstToSecond.occurrency <- evoPath$occurrency[firstGeneClass.id,,drop=F]
    firstToSecond.occurrency <- firstToSecond.occurrency[,secondGeneClass.id,drop=F]
    firstToSecond.occ.val <- sum(apply(firstToSecond.occurrency,1,sum),na.rm=T)
    
    secondToFirst.occurrency <- evoPath$occurrency[secondGeneClass.id,,drop=F]
    secondToFirst.occurrency <- secondToFirst.occurrency[,firstGeneClass.id,drop=F]
    secondToFirst.occ.val <- sum(apply(secondToFirst.occurrency,1,sum),na.rm=T)    
    
    outDF <- data.frame(row.names=geneClassesComb[,combID] )
    outDF$source <- NA
    outDF$dest <- NA
    outDF$causality <- NA
    outDF$occurrency <- NA
  
    outDF$source[1] <- firstClass
    outDF$dest[1] <- secondClass
    outDF$source[2] <- secondClass
    outDF$dest[2] <- firstClass
  
    outDF$causality[1] <- firstToSecond.caus.val
    outDF$causality[2] <- secondToFirst.caus.val
    outDF$occurrency[1] <- firstToSecond.occ.val  
    outDF$occurrency[2] <- secondToFirst.occ.val
    
    return(outDF)
  }
  
  combinationsDep.list <- mclapply(seq(1:ncol(geneClassesComb)),getCombDep,geneClassesComb, geneClasses, evoPath,mc.cores=4,mc.preschedule=F)
#  lapply(seq(1:ncol(geneClassesComb)),getCombDep,geneClassesComb, geneClasses, evoPath)
  
  combinationsDep <- fromListToDF(combinationsDep.list)

  outDep.causality <-acast(combinationsDep,source~dest,value.var="causality",fill=0 )
  
  outDep.occurrency <- acast(combinationsDep,source~dest,value.var="occurrency",fill=0 )
  
  return(list(causality = outDep.causality, occurrency = outDep.occurrency ))  
  
}


### Aggreate n classes
## it takes a list of gene classes, where a class is a set of genes
## the classes CAN have intersection
## and compute the agggregated evoPath
## node labels are list names
# evoPath <- genesEvolutionPath.pr
# geneClasses <- geneListGO
evoPath.projectOnGenes.withIntersection <- function(evoPath, geneClasses, name.separator="~"  ){
  
  nClasses <- length(names(geneClasses))
  nameClasses <- names(geneClasses)
  out.causality <- matrix(data=0,nrow=nClasses,nClasses)
  rownames(out.causality) <- nameClasses
  colnames(out.causality) <- nameClasses
  out.occurrency <- out.causality
  
  geneClassesComb <- combn(nameClasses,m=2)
  
  #  combID <- 2
  getCombDep <- function(combID, geneClassesComb, geneClasses, evoPath){
    
    cat(combID,".. ")
    firstClass <- geneClassesComb[1,combID]
    secondClass <- geneClassesComb[2,combID]
    
    evoPath.geneList <- do.call(rbind,strsplit(rownames(evoPath$causality),split=name.separator) )
    
    genelist1 <- geneClasses[[firstClass]]
    genelist2 <- geneClasses[[secondClass]]
    genelist1.noInt <- setdiff(genelist1,genelist2)
    genelist2.noInt <- setdiff(genelist2,genelist1)
    
    firstGeneClass.id <-  which( evoPath.geneList[,1] %in% genelist1.noInt )
    secondGeneClass.id <-  which( evoPath.geneList[,1] %in% genelist2.noInt )
    
    
    firstToSecond.causality <- evoPath$causality[firstGeneClass.id,,drop=F]
    firstToSecond.causality <- firstToSecond.causality[,secondGeneClass.id,drop=F]
    firstToSecond.caus.val <- sum(apply(firstToSecond.causality,1,sum),na.rm=T)
    
    secondToFirst.causality <- evoPath$causality[secondGeneClass.id,,drop=F]
    secondToFirst.causality <- secondToFirst.causality[,firstGeneClass.id,drop=F]
    secondToFirst.caus.val <- sum(apply(secondToFirst.causality,1,sum),na.rm=T)
    
    firstToSecond.occurrency <- evoPath$occurrency[firstGeneClass.id,,drop=F]
    firstToSecond.occurrency <- firstToSecond.occurrency[,secondGeneClass.id,drop=F]
    firstToSecond.occ.val <- sum(apply(firstToSecond.occurrency,1,sum),na.rm=T)
    
    secondToFirst.occurrency <- evoPath$occurrency[secondGeneClass.id,,drop=F]
    secondToFirst.occurrency <- secondToFirst.occurrency[,firstGeneClass.id,drop=F]
    secondToFirst.occ.val <- sum(apply(secondToFirst.occurrency,1,sum),na.rm=T)    
    
    outDF <- data.frame(row.names=geneClassesComb[,combID] )
    outDF$source <- NA
    outDF$dest <- NA
    outDF$causality <- NA
    outDF$occurrency <- NA
    
    outDF$source[1] <- firstClass
    outDF$dest[1] <- secondClass
    outDF$source[2] <- secondClass
    outDF$dest[2] <- firstClass
    
    outDF$causality[1] <- firstToSecond.caus.val
    outDF$causality[2] <- secondToFirst.caus.val
    outDF$occurrency[1] <- firstToSecond.occ.val  
    outDF$occurrency[2] <- secondToFirst.occ.val
    
    return(outDF)
  }
  
  combinationsDep.list <- mclapply(seq(1:ncol(geneClassesComb)),getCombDep,geneClassesComb, geneClasses, evoPath,mc.cores=4,mc.preschedule=F)
  #  lapply(seq(1:ncol(geneClassesComb)),getCombDep,geneClassesComb, geneClasses, evoPath)
  
  combinationsDep <- fromListToDF(combinationsDep.list)
  
  outDep.causality <-acast(combinationsDep,source~dest,value.var="causality",fill=0 )
  
  outDep.occurrency <- acast(combinationsDep,source~dest,value.var="occurrency",fill=0 )
  
  return(list(causality = outDep.causality, occurrency = outDep.occurrency ))  
  
}






### Remove duplicates
removeDup <- function(i,geneData.CN,dupNames){
  if (!geneData.CN$unique[i] %in% dupNames){
    return(geneData.CN[i,])
  }else{
    this.ids <- which(geneData.CN$unique == geneData.CN$unique[i])
    if ( this.ids[which.max(geneData.CN$perc.overlap[this.ids])]  == i){
      return(geneData.CN[i,])
    }else{
      geneData.CN$clonality.status[i] <- "not.analysed"
      return(geneData.CN[i,])
    }
  }
}









### Other filters
filterGenesEvolutionPath.aggreateMutationType <- function(genesEvolutionPath, minDependency = 0 , minOccurency = 0, minPerc = 0, toForce.genes = c(), toForce.aberrations = c(),name.separator="~" ){
  
  genesEvolutionPath.causality <- genesEvolutionPath$causality
  genesEvolutionPath.occurrency <- genesEvolutionPath$occurrency
  
  #find index of causality that does not respect minDependecy
  minDepToRemove <- which(genesEvolutionPath.causality < minDependency)
  
  #find index of occurency that does not respect minOccurency
  minOccToRemove <- which(genesEvolutionPath.occurrency < minOccurency)
  
  #find index of occurency and dependency that does not respect minPerc  
  minPercToRemove <- which( is.nan(genesEvolutionPath.causality / genesEvolutionPath.occurrency) | 
                              ((genesEvolutionPath.causality / genesEvolutionPath.occurrency) < minPerc))
  
  ToRemove <- unique(c(minDepToRemove,minOccToRemove,minPercToRemove))
  
  
  #remove toForce genes from remove lists
  toForce <- sapply(toForce.genes,
                    function(x,toForce.aberrations,name.separator){
                      paste(x,toForce.aberrations,sep=name.separator)
                    },toForce.aberrations,name.separator)
  #maybe not needed
  toForce.names <- Reduce(rbind,toForce)[,1]
  toForce.rowsANDclols <- which(colnames(genesEvolutionPath.causality) %in% toForce.names)
  
  if (length(toForce.rowsANDclols) > 0){
    genesEvolutionPath.causality.bkp <- genesEvolutionPath.causality
    genesEvolutionPath.occurrency.bkp <- genesEvolutionPath.occurrency
  }
  
  ## set ot zero filtered relations
  
  genesEvolutionPath.causality[ToRemove] <- 0
  genesEvolutionPath.occurrency[ToRemove] <- 0

  #add forces
  if (length(toForce.rowsANDclols) > 0){
    genesEvolutionPath.causality[toForce.rowsANDclols,] <- genesEvolutionPath.causality.bkp[toForce.rowsANDclols,]
    genesEvolutionPath.causality[,toForce.rowsANDclols] <- genesEvolutionPath.causality.bkp[,toForce.rowsANDclols]
    genesEvolutionPath.occurrency[toForce.rowsANDclols,] <- genesEvolutionPath.occurrency.bkp[toForce.rowsANDclols,]
    genesEvolutionPath.occurrency[,toForce.rowsANDclols] <- genesEvolutionPath.occurrency.bkp[,toForce.rowsANDclols]
    
  }
  
  
  return(list(causality = genesEvolutionPath.causality, occurrency = genesEvolutionPath.occurrency ))
}



#countClonalityDependecy_function = "countClonalityDependecy.fast3"
#list_of_clonalityTables <- list_of_clonalityTables.CpSn
#create dep graph with multiple aberrations
countClonalityDependecy.aggreateMutationType <- function(countClonalityDependecy_function, list_of_clonalityTables, clonalStatus = clonalStatus,subclonalStatus = subclonalStatus,name.separator="~", ncores=4){
  #set function that work on single mutation
  countClonalityDependecy <- match.fun(countClonalityDependecy_function)
  
  #set the name of the gene as gene _ mutation type
  #aberration <- names(list_of_clonalityTables)[3]
  for(aberration in names(list_of_clonalityTables)){
    if ( length(list_of_clonalityTables[[aberration]]$Gene.id) > 0){
      list_of_clonalityTables[[aberration]]$Gene.id <- paste0(list_of_clonalityTables[[aberration]]$Gene.id,name.separator,aberration)
    }
  }  
  
  clonalityTable <- fromListToDF(lapply(list_of_clonalityTables,function(x){return(x[,1:15])})    )
  
  genesEvolutionPath <- countClonalityDependecy(clonality=clonalityTable,clonalStatus,subclonalStatus,ncores=ncores)
  return(genesEvolutionPath)
}


#clonality.this <- clonalityGoodGenes
#compute summary of deletions: % of deletions, % of subclonality
getMutationsStats <- function(clonality.this,nSamples,clonalStatus,subclonalStatus){
  
  #subSet clonality
  #clonality.this <- clonality[which(clonality$Tumor.Type == tumorType & clonality$Variation.Type == mutations),]
  
  dataTable <- data.frame(row.names=unique(clonality.this$Gene.id))
  dataTable$n.samples <- rep(NA,nrow(dataTable))
  dataTable$n.mutated <- rep(NA,nrow(dataTable))
  dataTable$n.mutated.clonal <- rep(NA,nrow(dataTable))
  dataTable$n.mutated.subclonal <- rep(NA,nrow(dataTable))
  
  geneName <- unique(clonality.this$Gene.id)[1]
  for(geneName in unique(clonality.this$Gene.id)){
    dataTable[geneName,"n.samples"] <- nSamples
    dataTable[geneName,"n.mutated"] <- length(which(clonality.this$Gene.id == geneName))    
    dataTable[geneName,"n.mutated.clonal"] <- length(which(clonality.this$Gene.id == geneName & clonality.this$clonality.status %in% clonalStatus))
    dataTable[geneName,"n.mutated.subclonal"] <- length(which(clonality.this$Gene.id == geneName & clonality.this$clonality.status %in% subclonalStatus))
  }
  
  return(dataTable)
  
}

#creae dependency and occurency matrix
countClonalityDependecy.fast3 <- function(clonality,clonalStatus, subclonalStatus, ncores = 4){
  
  #causalityMatrix <- apply(clonality_info$clonalityClass,c(1,2),function(x){return(min(x,0))} )
  #occurencyMatrix <- apply(clonality_info$clonalityClass,c(1,2),function(x){return(min(x,0))} )
  
  geneNames <- unique(clonality$Gene.id)
  num_of_genes <- length(geneNames)
  
  causalityMatrix <- matrix(data=0, ncol = num_of_genes, nrow = num_of_genes)
  
  colnames(causalityMatrix) <- geneNames
  rownames(causalityMatrix) <- geneNames
  occurrencyMatrix <- causalityMatrix
  clonality.bySample <- by(clonality,INDICES=clonality$sample,FUN=identity)
  
  indexCols <- c(1:ncol(causalityMatrix))
  indexRows <- c(1:nrow(causalityMatrix))
  names(indexCols) <- colnames(causalityMatrix)
  names(indexRows) <- rownames(causalityMatrix)
  
  #pairId <- 166
  getDep <- function(pairId,relations,thisSample){
    
    pair <- relations[,pairId]
    
    outDF <- data.frame(row.names=c(1:2))
    outDF$row[1] = indexRows[pair[1]]
    outDF$col[1] = indexCols[pair[2]]
    
    outDF$row[2] = indexRows[pair[2]]
    outDF$col[2] = indexCols[pair[1]]
    
    outDF$causality = 0
    outDF$occurency = 0
    
    if (status[pair[1]] %in% clonalStatus &&   status[pair[2]] %in% subclonalStatus ){
      outDF$causality[1] <- outDF$causality[1] + 1
    }
    #cat("Here")
    if (status[pair[1]] %in% subclonalStatus  &&   status[pair[2]] %in%  clonalStatus){
      outDF$causality[2] <- outDF$causality[2] + 1
    }

    
    #cat("Here")
    outDF$occurency  <- outDF$occurency  + 1
    #outDF$cooccurency  <- outDF$cooccurency  + 1
    
    #cat("Here")
    #outDF$occurency <- outDF$occurency  + 1
    
    return(outDF)
  }
  
  ### Extract status for each combination in each sample
  #statusCombinations <- c()
  #i<-17
  cat("Sample ")
  for(i in c(1:length(clonality.bySample))){
    cat(i,".. ")
    thisSample <- clonality.bySample[[i]]
    genes <- thisSample$Gene.id[which(! thisSample$clonality.status %in% "not.analysed")]
    
    if(length(unique(genes)) < 2){
      next
    }
    
    status <- thisSample$clonality.status[which(! thisSample$clonality.status %in% "not.analysed")]
    names(status) <- genes
    
    relations <- combn(genes,2)
    autoRelations <- which(relations[1,] == relations[2,])
    if (length(autoRelations) > 0){
      relations <- relations[,-autoRelations]
    }
    #rownames(thisSample) <- thisSample$Gene.id
    # tmpID <- which(relations[2,] == "SPOP~pm")
    
    thisSample.matrix.list <- mclapply(c(1:ncol(relations)),getDep,relations,thisSample,mc.preschedule=T,mc.cores=ncores )
    
    thisSample.matrix.idx <- fromListToDF(thisSample.matrix.list) 
    #class(which(causalityMatrix ==0 , arr.ind=T))
    #class( thisSample.matrix.idx[,1:2])
    
    causalityMatrix[as.matrix(thisSample.matrix.idx[,1:2])] <- causalityMatrix[as.matrix(thisSample.matrix.idx[,1:2])] + thisSample.matrix.idx$causality
    occurrencyMatrix[as.matrix(thisSample.matrix.idx[,1:2])] <- occurrencyMatrix[as.matrix(thisSample.matrix.idx[,1:2])] + thisSample.matrix.idx$occurency
    
  }
  cat("\n")
  
  return(list(causality = causalityMatrix, occurrency = occurrencyMatrix))
}


#plot dep graph aggregates
#nodesInfo <- genesInfo
plotDependencyGraph.aggreateMutationType <- function(clonality.dep,clonality.stats.list,vertexPal,plotElabels=T,name.separator="~",minDep=1, nodesInfo=NULL, plot=T ){
  
  n_color_levels <- length(vertexPal)
  
  #save causality
  causalityMat <- clonality.dep$causality
  #save dependecy
  occurencyMat <- clonality.dep$occurrency
  
  adjacencyMatrix <- matrix(data=0, nrow = nrow(occurencyMat), ncol = ncol(occurencyMat))
  colnames(adjacencyMatrix) <- colnames(occurencyMat)
  rownames(adjacencyMatrix) <- rownames(occurencyMat)
  
  e_names <- c()
  e_occur <- c()
  e_dep <- c()
  
  #which(causalityMat > 0,arr.ind=T)
  #which(occurencyMat >0 ,arr.ind=T)
  
  for(start in c(1:dim(causalityMat)[1])){
    for(end in c(1:dim(causalityMat)[2])){    
      val <- causalityMat[start,end]
      tot <- occurencyMat[start,end]
      if ( val >= minDep & tot > 0){
        adjacencyMatrix[start,end] <- val
        e_names <- c(e_names,paste(val,tot,sep="/"))
        e_occur <- c(e_occur,tot)    
        e_dep <- c(e_dep,val)
      }
    }
  }
  
  v_names_long <-  names(which( apply(adjacencyMatrix,1,sum) > 0 | apply(adjacencyMatrix,2,sum) > 0 ))
  v_names <- do.call(rbind,strsplit(v_names_long,split=name.separator))[,1]
  v_aberration <- do.call(rbind,strsplit(v_names_long,split=name.separator))[,2]
  
  adjacencyMatrix <- adjacencyMatrix[v_names_long,v_names_long]
  
  g <- graph.adjacency(adjmatrix=adjacencyMatrix,  weighted=TRUE, 
                       mode="directed", add.colnames = NULL )
  
  if ( length(E(g)) > 0 ){
    V(g)$label <- v_names
    #V(g)$shape <- "square"
    V(g)$frame.color <- NA
    V(g)$label.cex <- 1.3
    V(g)$label.dist <- 0.7
    V(g)$label.color <- "black"
    #V(g)$label.family <- "serif"
    
    ## add extra info
    if (! is.null(nodesInfo)){
      parValue <- colnames(nodesInfo)[1]
      for(parValue in colnames(nodesInfo)){
        if (!is.na(parValue)){    
          g<-set.vertex.attribute(g, parValue, V(g), nodesInfo[V(g)$label,parValue]  )  
        }
      }  
    }
    
    #compute shapes
    #"circle", "square", "csquare", "rectangle", "crectangle", "vrectangle", "pie" 
    availableShapes <- c("circle", "rectangle","square",  "crectangle")
    names(availableShapes) <- c("loss","gain","pm","bp")
    V(g)$shape <- availableShapes[v_aberration]
    V(g)$aberration <- v_aberration
    
    if(plotElabels){
      E(g)$label <- e_names  
    }
    
    E(g)$occurrency <- e_occur
    E(g)$dependency <- e_dep  
    E(g)$curved <- 0.1
    E(g)$arrow.size = 0.5
    
    #add stats info
    
    #resort stat table
    
    #vertex dimension is proportional to % of deletions  
    #names(clonality.stats.list)
    clonality.stats.names.list <- lapply(clonality.stats.list,function(x){rownames(x)})
    clonality.stats.names <- c()
    for(i in c(1:length(clonality.stats.names.list))){
      if (length(clonality.stats.names.list[[i]]) > 0){
        clonality.stats.names <- c(clonality.stats.names,paste0(clonality.stats.names.list[[i]],name.separator,names(clonality.stats.list)[i]))  
      }    
      #rownames(clonality.stats.list[[i]]) <- paste0(rownames(clonality.stats.list[[i]]),name.separator,names(clonality.stats.list)[i])
    }
    clonality.stats <- fromListToDF(clonality.stats.list)
    rownames(clonality.stats) <- clonality.stats.names
    clonality.stats <- clonality.stats[v_names_long, ]
    
    V(g)$percDel <- round(clonality.stats$n.mutated / clonality.stats$n.samples,2)
    
    correctionFactor <- 50
    vertexSizes <- correctionFactor * V(g)$percDel
    V(g)$size <- vertexSizes
    V(g)$size2 <- vertexSizes/2
    
    
    #vertex color is proportional to subclonality
    V(g)$percSub <- clonality.stats$n.mutated.subclonal / (clonality.stats$n.mutated.clonal + clonality.stats$n.mutated.subclonal)
    
    #rank colors
    vertexCol <- rep(NA,length(V(g)$percSub))  
    
    #i<-3
    for(i in c(1:length(vertexCol))){
      #vertexCol[i] <- vertexPal[tail(rank(c(seq(0,1,length.out=n_color_levels+1),0.9),ties.method="min" ),n=1)-1]    
      vertexCol[i] <- max(1,tail(rank(c(seq(0,1,length.out=n_color_levels+1),V(g)$percSub[i]),ties.method="min" ),n=1)-1)
    }
    
    V(g)$color <- vertexPal[vertexCol] 
    
    
    #plot.igraph(g,vertex.label.dist=1)
    if (plot){
      tkplot(g,vertex.label.dist=1)  
    }
    
  }
  
  return(g)
  
}


# Wrog!! to check code
#plot dep graph aggregates
#nodesInfo <- genesInfo
plotDependencyGraph.aggreateMutationType.fast <- function(clonality.dep,clonality.stats.list,vertexPal,plotElabels=T,name.separator="~",minDep=1, nodesInfo=NULL, plot=T ){
  
  n_color_levels <- length(vertexPal)
  
  #save causality
  causalityMat <- clonality.dep$causality
  
  #save dependecy
  occurencyMat <- clonality.dep$occurrency
  
  adjacencyMatrix <- matrix(data=0, nrow = nrow(occurencyMat), ncol = ncol(occurencyMat))
  colnames(adjacencyMatrix) <- colnames(occurencyMat)
  rownames(adjacencyMatrix) <- rownames(occurencyMat)
  goodIDs <- which(causalityMat >= minDep)
  adjacencyMatrix[goodIDs] <- causalityMat[goodIDs]
  
 
  e_occur <- occurencyMat[goodIDs]
  e_dep <- causalityMat[goodIDs]
  
  v_names_long <-  names(which( apply(adjacencyMatrix,1,sum) > 0 | apply(adjacencyMatrix,2,sum) > 0 ))
  v_names <- do.call(rbind,strsplit(v_names_long,split=name.separator))[,1]
  v_aberration <- do.call(rbind,strsplit(v_names_long,split=name.separator))[,2]
  
  adjacencyMatrix <- adjacencyMatrix[v_names_long,v_names_long]
  
  g <- graph.adjacency(adjmatrix=adjacencyMatrix,  weighted=TRUE, 
                       mode="directed", add.colnames = NULL )
  
  
  V(g)$gene <- v_names
  V(g)$label <- v_names_long
  
  #V(g)$shape <- "square"
  V(g)$frame.color <- NA
  V(g)$label.cex <- 1.3
  V(g)$label.dist <- 0.7
  V(g)$label.color <- "black"
  #V(g)$label.family <- "serif"
  
  ## add extra info
  if (! is.null(nodesInfo)){
    parValue <- colnames(nodesInfo)[1]
    for(parValue in colnames(nodesInfo)){
      if (!is.na(parValue)){    
        g<-set.vertex.attribute(g, parValue, V(g), nodesInfo[V(g)$gene,parValue]  )  
      }
    }  
  }
  
  
  #compute shapes
  V(g)$aberration <- v_aberration
  
  if(plotElabels){
    E(g)$label <- e_dep
  }
  
  E(g)$occurrency <- e_occur
  E(g)$dependency <- e_dep  
  E(g)$curved <- 0.1
  E(g)$arrow.size = 0.5
  
  #add stats info
  
  #resort stat table
  
  
  #V(g)$color <- vertexPal[vertexCol] 
  
  
  #plot.igraph(g,vertex.label.dist=1)
  if (plot){
    tkplot(g,vertex.label.dist=1)  
  }  
  
  
  #pdf("/home/prandi/Dropbox/TCGAproject/Figures/Report/Aggressive_ManualReview/EvoPaths/evoPath.Actionable_Genes_NatureKan_Sylvan_0712_minDep3.test.pdf",width=8,height=8)
  #plot(g)
  #dev.off()
  return(g)
  
}




#clonality.dep <- genesEvolutionPath.GO.pr
plotDependencyGraph.aggregate <- function(clonality.dep,minDep=1){
  
  
    #save causality
    causalityMat <- clonality.dep$causality
    
    #save dependecy
    occurencyMat <- clonality.dep$occurrency
    
    adjacencyMatrix <- matrix(data=0, nrow = nrow(occurencyMat), ncol = ncol(occurencyMat))
    colnames(adjacencyMatrix) <- colnames(occurencyMat)
    rownames(adjacencyMatrix) <- rownames(occurencyMat)
    
    e_names <- c()
    e_occur <- c()
    e_dep <- c()
    
    which(causalityMat > 0,arr.ind=T)
    which(occurencyMat >0 ,arr.ind=T)
    
    for(start in c(1:dim(causalityMat)[1])){
      for(end in c(1:dim(causalityMat)[2])){    
        val <- causalityMat[start,end]
        tot <- occurencyMat[start,end]
        if ( val >= minDep & tot > 0){
          adjacencyMatrix[start,end] <- val
          e_names <- c(e_names,paste(val,tot,sep="/"))
          e_occur <- c(e_occur,tot)    
          e_dep <- c(e_dep,val)
        }
      }
    }
    
    v_names <-  names(which( apply(adjacencyMatrix,1,sum) > 0 | apply(adjacencyMatrix,2,sum) > 0 ))
    
    adjacencyMatrix <- adjacencyMatrix[v_names,v_names]
    
    g <- graph.adjacency(adjmatrix=adjacencyMatrix,  weighted=TRUE, 
                         mode="directed", add.colnames = NULL )
    
    
    V(g)$label <- v_names
    
    #if(plotElabels){
    #  E(g)$label <- e_names  
    #}
    
    E(g)$label <- e_dep  
    #E(g)$occurrency <- e_occur
    #E(g)$dependency <- e_dep  
    #E(g)$curved <- 0.2
    #E(g)$arrow.size = 0.5
    
    #add stats info
    
    #resort stat table
    
    tkplot(g,vertex.label.dist=1)
    
    #pdf("/home/prandi/Dropbox/TCGAproject/Figures/Report/Aggressive_ManualReview/EvoPaths/evoPath.Actionable_Genes_NatureKan_Sylvan_0712_minDep3.test.pdf",width=8,height=8)
    #plot(g)
    #dev.off()
    return(g)
    
  }




#plot legends
plotColorLegend <- function(vertexPal){
  npoints <- length(vertexPal)
  plot(NA,xlim=c(0,npoints),ylim=c(0,1),axes=F,xlab="",ylab="")
  for(pos in c(1:npoints)){
    rect(pos-1,0,pos,1,col=vertexPal[pos],border=vertexPal[pos])
  }
}


plotSizeLegend <- function(g){
  #V(gPr)$percDel
  #V(gPr)$size
  sizes <- sort(V(g)$size)
  maxSize <- max(sizes)+1
  percs <- sort(V(g)$percDel)
  npoints <- length(sizes)
  plot(NA,xlim=c(0,npoints*max(sizes)),ylim=c(0,max(sizes)),axes=F,xlab="",ylab="")  
  x_coords= ( maxSize*seq(1:npoints) - (maxSize / 2))
  y_coords = rep((maxSize/2),npoints)
  radii = (sizes/2)
  symbols(x=x_coords  ,y= y_coords ,circles= radii  ,add=T,inches =F)
  
  text(x=x_coords,y= 2*y_coords, labels=percs  )
}



## Try to build a matrix where rows correspond to dependencies and columns to samples.
## Put 1 if a dep if present. -1 one if its reverse is present. 0 if anything is known.
## aberrationTables is a list of geneData table, one for each aberration considered
## the name of the tables in the list have to be equal to the name of the aberrations
## used in the dGraph



getDependencyHeatmap.aggreateMutationType <- function(list_of_clonalityTables, clonalStatus = clonalStatus,subclonalStatus = subclonalStatus
                                                      ,name.separator.mutation="~",name.separator.dep="[]", ncores=4,
                                                      statusCombinations){
  #set function that work on single mutation
  #countClonalityDependecy <- match.fun(countClonalityDependecy_function)
  
  #set the name of the gene as gene _ mutation type
  #aberration <- names(list_of_clonalityTables)[2]
  for(aberration in names(list_of_clonalityTables)){
    if ( length(list_of_clonalityTables[[aberration]]$Gene.id) > 0){
      list_of_clonalityTables[[aberration]]$Gene.id <- paste0(list_of_clonalityTables[[aberration]]$Gene.id,name.separator.mutation,aberration)
    }
  }  
  
  clonalityTable <- fromListToDF(lapply(list_of_clonalityTables,function(x){return(x[,1:15])})    )
  
  aberrationsDepStatus <- getDependencyStatus(clonality=clonalityTable,clonalStatus,subclonalStatus,ncores=ncores,
                                              name.separator=name.separator.dep,statusCombinations=statusCombinations)
  return(aberrationsDepStatus)
}



#creae dependency and occurency matrix
getDependencyStatus <- function(clonality,clonalStatus, subclonalStatus, ncores = 4,name.separator=" ",statusCombinations){
  
  #causalityMatrix <- apply(clonality_info$clonalityClass,c(1,2),function(x){return(min(x,0))} )
  #occurencyMatrix <- apply(clonality_info$clonalityClass,c(1,2),function(x){return(min(x,0))} )
  
  geneNames <- unique(clonality$Gene.id)
  num_of_genes <- length(geneNames)
  samplesName <- unique(clonality$sample)
  num_of_samples <- unique(samplesName)
  
  genesCombinations <- t(combn(geneNames,2))
  
  genesCombinations.names <- apply(genesCombinations,1,function(x)( paste(x[1],x[2],sep=name.separator)))
  
  dependencyStatus <- data.frame(row.names=genesCombinations.names,stringsAsFactors=F)
  #init colnames to NA
  for(sName in samplesName){
    dependencyStatus[,sName] <- statusCombinations$Na
  }
  
  clonality.bySample <- by(clonality,INDICES=clonality$sample,FUN=identity)
  
#  pairId <- 1
  getDepStatus <- function(pairId,relations,status){
  
    ## status code for aberrations A and B
    #A -> B 1
    #B -> A 2
    #A and B clonal 3
    #A and B subclonal 4
    #A or B NA  NA
    
    
    pair <- relations[,pairId]
    
    pairName <- paste(pair[1],pair[2],sep=name.separator)
    
    outDF <- data.frame(row.names=pairName)
    outDF$name <- pairName
    outDF$dep <-  statusCombinations$Na
    
    
    
    if (status[pair[1]] %in% clonalStatus &&   status[pair[2]] %in% subclonalStatus ){
      outDF$dep <-  statusCombinations$direct
    }
    #cat("Here")
    if (status[pair[1]] %in% subclonalStatus  &&   status[pair[2]] %in%  clonalStatus){
      outDF$dep <-  statusCombinations$inverse
    }
    
    if (status[pair[1]] %in% clonalStatus  &&   status[pair[2]] %in%  clonalStatus){
      outDF$dep <-  statusCombinations$clonal
    }
    
    if (status[pair[1]] %in% subclonalStatus  &&   status[pair[2]] %in%  subclonalStatus){
      outDF$dep <-  statusCombinations$subclonal
    }

    return(outDF)
  }
  
  ### Extract status for each combination in each sample
  #statusCombinations <- c()
  #i<-115
  for(i in c(1:length(clonality.bySample))){
    cat(i,"..")
    #readline()
  
    thisSample <- clonality.bySample[[i]]
    genes <- thisSample$Gene.id
    
    if(length(unique(genes)) < 2){
      next
    }
    
    status <- thisSample$clonality.status
    names(status) <- genes
    
    relations <- combn(genes,2)
    autoRelations <- which(relations[1,] == relations[2,])
    if (length(autoRelations) > 0){
      relations <- relations[,-autoRelations]
    }
    #rownames(thisSample) <- thisSample$Gene.id
    
    
    thisSample.matrix.list <- mclapply(c(1:ncol(relations)),getDepStatus,relations,status,mc.preschedule=T,mc.cores=ncores )
    
    thisSample.matrix.idx <- fromListToDF(thisSample.matrix.list) 
    badNames <- which(!(thisSample.matrix.idx$name %in% rownames(dependencyStatus)))
    if(length(badNames) > 0 ){
      for(badId in badNames){
        splitName <- strsplit(x=thisSample.matrix.idx$name[badId],split=name.separator)[[1]]
        thisSample.matrix.idx$name[badId] <- paste0(splitName[2],name.separator,splitName[1])
      }
      
    }
    
    dependencyStatus[ thisSample.matrix.idx$name,thisSample$sample[1]] <- thisSample.matrix.idx$dep
    
  }
  
  
  return(dependencyStatus)
}


#plot dependency status as an heatmap









##############################################################################
##############################################################################
##############################################################################
####################################### Old
#######################################
#######################################
##############################################################################
##############################################################################
##############################################################################
# 
# filterGenesEvolutionPath <- function(genesEvolutionPath, minDependency = 0 , minOccurency = 0, minPerc = 0, toForce = c()){
#   genesEvolutionPath.causality <- genesEvolutionPath$causality
#   genesEvolutionPath.occurrency <- genesEvolutionPath$occurrency
#   
#   #find index of causality that does not respect minDependecy
#   minDepToRemove <- which(genesEvolutionPath.causality < minDependency,arr.ind=T)
#   
#   #find index of occurency that does not respect minOccurency
#   minOccToRemove <- which(genesEvolutionPath.occurrency < minOccurency,arr.ind=T)
#   
#   #find index of occurency and dependency that does not respect minPerc  
#   minPercToRemove <- which( is.nan(genesEvolutionPath.causality / genesEvolutionPath.occurrency) < minPerc ,arr.ind= T)
#   
#   #remove toForce genes from remove lists
#   toForceIdx <- which(rownames(genesEvolutionPath.causality) %in% toForce)
#   
#   toForceDepIdx <- which( minDepToRemove[,1] %in% toForceIdx | minDepToRemove[,2] %in% toForceIdx  )
#   toForceOccIdx <- which( minOccToRemove[,1] %in% toForceIdx | minOccToRemove[,2] %in% toForceIdx  )
#   toForcePercIdx <- which( minPercToRemove[,1] %in% toForceIdx | minPercToRemove[,2] %in% toForceIdx  )
#   
#   if (length(toForceDepIdx) > 0){
#     minDepToRemove <- minDepToRemove[-toForceDepIdx,]
#   }
#   if (length(toForceOccIdx) > 0){
#     minOccToRemove <- minOccToRemove[-toForceOccIdx,]
#   }
#   if (length(toForceDepIdx) > 0){
#     minPercToRemove <- minPercToRemove[-toForcePercIdx,]
#   }
#   
#   ## set ot zero filtered relations
#   genesEvolutionPath.causality[minDepToRemove] <- 0
#   genesEvolutionPath.causality[minOccToRemove] <- 0
#   genesEvolutionPath.causality[minPercToRemove] <- 0
#   
#   return(list(causality = genesEvolutionPath.causality, occurrency = genesEvolutionPath.occurrency ))
# }
# 
# 
# #remove duplicated genes
# selectRepesentativeSeg <- function(clonalityTable){
#   uniqueIDs <- unique(paste0(clonalityTable$Gene.id,"_",clonalityTable$sample))
#   
#   #outDF <- data.frame(row.names=uniqueIDs)
#   
#   outDF <- c()
#   
#   geneId <- uniqueIDs[1]
#   for(geneId in uniqueIDs){
#     tablePos <- which(paste0(clonalityTable$Gene.id,"_",clonalityTable$sample) == geneId)
#     if ( length(tablePos) == 1){
#       #outDF[geneId,] <- cloanlityTable[tablePos,]
#       outDF <- rbind(outDF,clonalityTable[tablePos,])
#     }else{
#       maxId <- which.max(clonalityTable$perc.overlap[tablePos] ) 
#       #outDF[geneId,] <- cloanlityTable[tablePos[maxId],]
#       outDF <- rbind(outDF,clonalityTable[tablePos[maxId],] )
#     }    
#   }
#   
#   if ( length(unique(paste0(outDF$Gene.id,"_",outDF$sample))) == nrow(outDF)){
#     return(outDF)
#   }else{
#     stop("Some duplicated gene-sample where not removed")
#   }
# }
# 
# 
# #clonality<-clonalityTable
# #creae dependency and occurency matrix
# countClonalityDependecy <- function(clonality,clonalStatus, subclonalStatus){
#   
#   #causalityMatrix <- apply(clonality_info$clonalityClass,c(1,2),function(x){return(min(x,0))} )
#   #occurencyMatrix <- apply(clonality_info$clonalityClass,c(1,2),function(x){return(min(x,0))} )
#   
#   geneNames <- unique(clonality$Gene.id)
#   num_of_genes <- length(geneNames)
#   
#   causalityMatrix <- matrix(data=0, ncol = num_of_genes, nrow = num_of_genes)
#   
#   colnames(causalityMatrix) <- geneNames
#   rownames(causalityMatrix) <- geneNames
#   occurrencyMatrix <- causalityMatrix
#   
#   clonality.bySample <- by(clonality,INDICES=clonality$sample,FUN=identity)
#   
#   #sample <- rownames(clonality_info$clonalityClass)[16]
#   #i<-1
#   for(i in c(1:length(clonality.bySample))){
#     thisSample <- clonality.bySample[[i]]
#     genes <- thisSample$Gene.id[which(! thisSample$clonality.status %in% "not.analysed")]
#     
#     if(length(genes) < 2){
#       next
#     }
#     
#     relations <- combn(genes,2)
#     #j<-1
#     for(j in c(1:ncol(relations))){
#       #for(j in c(1:1000)){
#       statusFirst <- thisSample$clonality.status[which(thisSample$Gene.id == relations[1,j]) ]
#       statusSecond <- thisSample$clonality.status[which(thisSample$Gene.id == relations[2,j]) ]
#       
#       cat(thisSample$sample[1]," ",j," ",relations[1,j]," ",statusFirst," ",relations[2,j]," ",statusSecond,"\n" )
#       
#       if (statusFirst %in% clonalStatus &&   statusSecond %in% subclonalStatus ){
#         causalityMatrix[relations[1,j],relations[2,j]] <- causalityMatrix[relations[1,j],relations[2,j]] + 1
#       }
#       
#       if (statusFirst %in% c("subclonal","uncertain.subclonal") &&   statusSecond %in% c("clonal","uncertain.clonal")){
#         causalityMatrix[relations[2,j],relations[1,j]] <- causalityMatrix[relations[2,j],relations[1,j]] + 1
#       }
#       occurrencyMatrix[relations[1,j],relations[2,j]] <- occurrencyMatrix[relations[1,j],relations[2,j]] + 1
#       occurrencyMatrix[relations[2,j],relations[1,j]] <- occurrencyMatrix[relations[2,j],relations[1,j]] + 1
#     }
#     
#   }
#   
#   return(list(causality = causalityMatrix, occurrency = occurrencyMatrix))
# }
# 
# 
# #clonality<-clonalityGoodGenes
# #creae dependency and occurency matrix
# countClonalityDependecy.fast <- function(clonality,clonalStatus, subclonalStatus, ncores = 4){
#   
#   #causalityMatrix <- apply(clonality_info$clonalityClass,c(1,2),function(x){return(min(x,0))} )
#   #occurencyMatrix <- apply(clonality_info$clonalityClass,c(1,2),function(x){return(min(x,0))} )
#   
#   geneNames <- unique(clonality$Gene.id)
#   num_of_genes <- length(geneNames)
#   
#   causalityMatrix <- matrix(data=0, ncol = num_of_genes, nrow = num_of_genes)
#   
#   colnames(causalityMatrix) <- geneNames
#   rownames(causalityMatrix) <- geneNames
#   occurrencyMatrix <- causalityMatrix
#   
#   clonality.bySample <- by(clonality,INDICES=clonality$sample,FUN=identity)
#   
#   ### Extract status for each combination in each sample
#   statusCombinations <- c()
#   for(i in c(1:length(clonality.bySample))){
#     thisSample <- clonality.bySample[[i]]
#     genes <- thisSample$Gene.id[which(! thisSample$clonality.status %in% "not.analysed")]
#     
#     if(length(genes) < 2){
#       next
#     }
#     
#     relations <- combn(genes,2)
#     rownames(thisSample) <- thisSample$Gene.id
#     
#     getDep <- function(pairId,relations,thisSample){
#       outDF <- data.frame(row.names=1)
#       outDF$firstGene <- relations[1,pairId]
#       outDF$secondGene <- relations[2,pairId]  
#       outDF$firstGeneStatus <- thisSample[relations[1,pairId],"clonality.status"] 
#       outDF$secondGeneStatus <- thisSample[relations[2,pairId],"clonality.status"]                                  
#       return(outDF)
#     }
#     
#     thisSample.status.list <- mclapply(c(1:ncol(relations)),getDep,relations,thisSample,mc.preschedule=T,mc.cores=ncores )
#     thisSample.status <- fromListToDF(thisSample.status.list)
#     
#     statusCombinations  <- rbind(statusCombinations,thisSample.status)  
#   }
#   
#   
#   setCausalityAndClonality <- function(j,statusCombinations){
#     cat(j,"\n")
#     singleStatus <- statusCombinations[j,]
#     if (singleStatus$firstGeneStatus %in% clonalStatus &&   singleStatus$secondGene %in% subclonalStatus ){
#       causalityMatrix[ singleStatus$firstGene , singleStatus$secondGene ] <- causalityMatrix[ singleStatus$firstGene , singleStatus$secondGene ] + 1
#     }
#     
#     if (singleStatus$firstGeneStatus %in% subclonalStatus  &&   singleStatus$secondGeneStatus %in%  clonalStatus){
#       causalityMatrix[singleStatus$secondGene,singleStatus$firstGene] <- causalityMatrix[singleStatus$secondGene,singleStatus$firstGene] + 1
#     }
#     occurrencyMatrix[singleStatus$firstGene , singleStatus$secondGene] <- occurrencyMatrix[singleStatus$firstGene , singleStatus$secondGene] + 1
#     occurrencyMatrix[singleStatus$secondGene,singleStatus$firstGene] <- occurrencyMatrix[singleStatus$secondGene,singleStatus$firstGene] + 1
#   }
#   
#   lapply( c(1:nrow(statusCombinations)),setCausalityAndClonality,statusCombinations)
#   
#   
#   
#   return(list(causality = causalityMatrix, occurrency = occurrencyMatrix))
# }
# 
# #creae dependency and occurency matrix
# countClonalityDependecy.fast2 <- function(clonality,clonalStatus, subclonalStatus, ncores = 4){
#   
#   #causalityMatrix <- apply(clonality_info$clonalityClass,c(1,2),function(x){return(min(x,0))} )
#   #occurencyMatrix <- apply(clonality_info$clonalityClass,c(1,2),function(x){return(min(x,0))} )
#   
#   geneNames <- unique(clonality$Gene.id)
#   num_of_genes <- length(geneNames)
#   
#   causalityMatrix <- matrix(data=0, ncol = num_of_genes, nrow = num_of_genes)
#   
#   colnames(causalityMatrix) <- geneNames
#   rownames(causalityMatrix) <- geneNames
#   occurrencyMatrix <- causalityMatrix
#   
#   clonality.bySample <- by(clonality,INDICES=clonality$sample,FUN=identity)
#   
#   ### Extract status for each combination in each sample
#   statusCombinations <- c()
#   for(i in c(1:length(clonality.bySample))){
#     thisSample <- clonality.bySample[[i]]
#     genes <- thisSample$Gene.id[which(! thisSample$clonality.status %in% "not.analysed")]
#     
#     if(length(genes) < 2){
#       next
#     }
#     
#     status <- thisSample$clonality.status[which(! thisSample$clonality.status %in% "not.analysed")]
#     names(status) <- genes
#     
#     relations <- combn(genes,2)
#     rownames(thisSample) <- thisSample$Gene.id
#     
#     getDep <- function(pairId,relations,thisSample,causalityMatrix,occurrencyMatrix){
#       
#       pair <- relations[,pairId]
#       #cat(pair[1],"->",pair[2],"\n")
#       if (status[pair[1]] %in% clonalStatus &&   status[pair[2]] %in% subclonalStatus ){
#         causalityMatrix[ pair[1] , pair[2] ] <- causalityMatrix[ pair[1] , pair[2] ] + 1
#       }
#       #cat("Here")
#       if (status[pair[1]] %in% subclonalStatus  &&   status[pair[2]] %in%  clonalStatus){
#         causalityMatrix[pair[2] , pair[1]] <- causalityMatrix[pair[2] , pair[1]] + 1
#       }
#       #cat("Here")
#       occurrencyMatrix[pair[1] , pair[2]] <- occurrencyMatrix[pair[1] , pair[2]] + 1
#       #cat("Here")
#       occurrencyMatrix[pair[2] , pair[1]] <- occurrencyMatrix[pair[2] , pair[1]] + 1
#       
#       return(cbind(causalityMatrix,occurrencyMatrix))
#     }
#     
#     thisSample.matrix.list <- mclapply(c(1:ncol(relations)),getDep,relations,thisSample,causalityMatrix,occurrencyMatrix,mc.preschedule=T,mc.cores=ncores )
#     thisSample.matrix <- Reduce('+',thisSample.matrix.list)
#     
#     causalityMatrix <- causalityMatrix + thisSample.matrix[1:nrow(thisSample.matrix),1:nrow(thisSample.matrix)]
#     occurrencyMatrix <- occurrencyMatrix + thisSample.matrix[1:nrow(thisSample.matrix),c(1:nrow(thisSample.matrix))+nrow(thisSample.matrix)]
#   }
#   return(list(causality = causalityMatrix, occurrency = occurrencyMatrix))
# }
# 
# 
# 
# #plot dep graph
# plotDependencyGraph  <- function(clonality.dep,clonality.stats,vertexPal,minDep,plotElabels=T){
#   
#   n_color_levels <- length(vertexPal)
#   
#   #save causality
#   causalityMat <- clonality.dep$causality
#   
#   #save dependecy
#   occurencyMat <- clonality.dep$occurrency
#   
#   adjacencyMatrix <- matrix(data=0, nrow = nrow(occurencyMat), ncol = ncol(occurencyMat))
#   colnames(adjacencyMatrix) <- colnames(occurencyMat)
#   rownames(adjacencyMatrix) <- rownames(occurencyMat)
#   
#   e_names <- c()
#   e_occur <- c()
#   e_dep <- c()
#   
#   which(causalityMat > 0,arr.ind=T)
#   which(occurencyMat >0 ,arr.ind=T)
#   
#   for(start in c(1:dim(causalityMat)[1])){
#     for(end in c(1:dim(causalityMat)[2])){    
#       val <- causalityMat[start,end]
#       tot <- occurencyMat[start,end]
#       if ( val >= minDep & tot > 0){
#         adjacencyMatrix[start,end] <- val
#         e_names <- c(e_names,paste(val,tot,sep="/"))
#         e_occur <- c(e_occur,tot)    
#         e_dep <- c(e_dep,val)
#       }
#     }
#   }
#   
#   v_names <-  names(which( apply(adjacencyMatrix,1,sum) > 0 | apply(adjacencyMatrix,2,sum) > 0 ))
#   
#   adjacencyMatrix <- adjacencyMatrix[v_names,v_names]
#   
#   g <- graph.adjacency(adjmatrix=adjacencyMatrix,  weighted=TRUE, 
#                        mode="directed", add.colnames = NULL )
#   
#   
#   V(g)$label <- v_names
#   #V(g)$shape <- "square"
#   V(g)$frame.color <- NA
#   V(g)$label.cex <- 1.3
#   V(g)$label.dist <- 0.7
#   V(g)$label.color <- "black"
#   V(g)$label.family <- "serif"
#   
#   if(plotElabels){
#     E(g)$label <- e_names  
#   }
#   
#   E(g)$occurrency <- e_occur
#   E(g)$dependency <- e_dep  
#   E(g)$curved <- 0.1
#   E(g)$arrow.size = 0.5
#   
#   #add stats info
#   
#   #resort stat table
#   clonality.stats <- clonality.stats[v_names, ]
#   
#   #vertex dimension is proportional to % of deletions  
#   V(g)$percDel <- round(clonality.stats$n.mutated / clonality.stats$n.samples,2)
#   correctionFactor <- 50
#   vertexSizes <- correctionFactor * V(g)$percDel
#   V(g)$size <- vertexSizes
#   
#   
#   
#   #vertex color is proportional to subclonality
#   V(g)$percSub <- clonality.stats$n.mutated.subclonal / (clonality.stats$n.mutated.clonal + clonality.stats$n.mutated.subclonal)
#   
#   #rank colors
#   vertexCol <- rep(NA,length(V(g)$percSub))  
#   
#   #i<-3
#   for(i in c(1:length(vertexCol))){
#     #vertexCol[i] <- vertexPal[tail(rank(c(seq(0,1,length.out=n_color_levels+1),0.9),ties.method="min" ),n=1)-1]    
#     vertexCol[i] <- max(1,tail(rank(c(seq(0,1,length.out=n_color_levels+1),V(g)$percSub[i]),ties.method="min" ),n=1)-1)
#   }
#   
#   V(g)$color <- vertexPal[vertexCol] 
#   
#   tkplot(g,vertex.label.dist=1)
#   
#   #pdf("/home/prandi/Dropbox/TCGAproject/Figures/Report/Aggressive_ManualReview/EvoPaths/evoPath.Actionable_Genes_NatureKan_Sylvan_0712_minDep3.test.pdf",width=8,height=8)
#   #plot(g)
#   #dev.off()
#   return(g)
#   
# }


# filterGenesEvolutionPath.aggreateMutationType <- function(genesEvolutionPath, minDependency = 0 , minOccurency = 0, minPerc = 0, toForce.genes = c(), toForce.aberrations = c(),name.separator="~" ){
#   
#   genesEvolutionPath.causality <- genesEvolutionPath$causality
#   genesEvolutionPath.occurrency <- genesEvolutionPath$occurrency
#   
#   #find index of causality that does not respect minDependecy
#   minDepToRemove <- which(genesEvolutionPath.causality < minDependency,arr.ind=T)
#   
#   #find index of occurency that does not respect minOccurency
#   minOccToRemove <- which(genesEvolutionPath.occurrency < minOccurency,arr.ind=T)
#   
#   #find index of occurency and dependency that does not respect minPerc  
#   minPercToRemove <- which( is.nan(genesEvolutionPath.causality / genesEvolutionPath.occurrency) | 
#                               ((genesEvolutionPath.causality / genesEvolutionPath.occurrency) < minPerc) ,arr.ind= T)
#   
#   #remove toForce genes from remove lists
#   toForce <- sapply(toForce.genes,
#                     function(x,toForce.aberrations,name.separator){
#                       paste(x,toForce.aberrations,sep=name.separator)
#                     },toForce.aberrations,name.separator)
#   #maybe not needed
#   toForce <- Reduce(rbind,toForce)[,1]
#   
#   
#   toForceIdx <- which(rownames(genesEvolutionPath.causality) %in% toForce)
#   
#   toForceDepIdx <- which( minDepToRemove[,1] %in% toForceIdx | minDepToRemove[,2] %in% toForceIdx  )
#   toForceOccIdx <- which( minOccToRemove[,1] %in% toForceIdx | minOccToRemove[,2] %in% toForceIdx  )
#   toForcePercIdx <- which( minPercToRemove[,1] %in% toForceIdx | minPercToRemove[,2] %in% toForceIdx  )
#   
#   if (length(toForceDepIdx) > 0){
#     minDepToRemove <- minDepToRemove[-toForceDepIdx,]
#   }
#   if (length(toForceOccIdx) > 0){
#     minOccToRemove <- minOccToRemove[-toForceOccIdx,]
#   }
#   if (length(toForceDepIdx) > 0){
#     # setdiff 
#     minPercToRemove <- minPercToRemove[-toForcePercIdx,]
#   }
#   
#   ## set ot zero filtered relations
#   
#   genesEvolutionPath.causality[minDepToRemove] <- 0
#   genesEvolutionPath.causality[minOccToRemove] <- 0  
#   genesEvolutionPath.causality[minPercToRemove] <- 0
#   
#   genesEvolutionPath.occurrency[minDepToRemove] <- 0  
#   genesEvolutionPath.occurrency[minOccToRemove] <- 0
#   genesEvolutionPath.occurrency[minPercToRemove] <- 0
#   return(list(causality = genesEvolutionPath.causality, occurrency = genesEvolutionPath.occurrency ))
# }
